/*
 *  Sensores Ir v0.10
 *  JIDS 10/10/2023  https://alinos.sytes.net 
 */
#include "Arduino.h"

// const int pin_inundacion = 7;   // Sensor de agua (pin digital)
const int pin_inundacion = A7;     // Sensor de agua (pin analógico)
const int pin_temperatura = 6;     // Sensor de temperatura y humedad relativa DHT22 (pin digital)
const int pin_llama = 4;           // Sensor de llama infrarrojo (pin digital)
const int pin_humo_digital = 5;    // Sensor de humo, GLP y CO - Sensor MQ-2 (pin digital)
const int pin_humo_analogico = A6;  // Sensor de humo, GLP MQ-2 (pin analógico)

/*
const int pin_rele1 = A1;  // Relé 1
const int pin_rele2 = A2;  // Relé 2
const int pin_rele3 = A3;  // Relé 3
const int pin_rele4 = A4;  // Relé 4
*/
//const byte interruptPin = 2;
//volatile boolean leer_rfid;

// Pantalla leds
uint8_t actualiza_pantalla = 0; 

  



#include <DHT.h>
//#include <MD_Parola.h>
#include <MD_MAX72xx.h>
//#include "Font7Seg.h"
#include <SPI.h>
#include <Wire.h>

#include "MQ2.h"
MQ2 mq2(pin_humo_analogico);
// int lpg, co, smoke;
int glp, co, humo;

// Display de leds
#define HARDWARE_TYPE MD_MAX72XX::FC16_HW
#define MAX_DEVICES 4  // Define the number of displays connected

#define CLK_PIN   13     // CLK or SCK
#define DATA_PIN   11    // DATA or MOSI
#define CS_PIN    8      // CS or SS
// #define SPEED_TIME 75  // Speed of the transition
// #define PAUSE_TIME 0
// #define MAX_MESG 20




#define DHTTYPE  DHT22
// DHT dht(pin_temperatura, DHTTYPE, 22); 
DHT dht(pin_temperatura,DHT22);
// dht DHT; // Crea un objeto DHT

// Display leds
// Hardware SPI connection
/*
MD_Parola P = MD_Parola(HARDWARE_TYPE, CS_PIN, MAX_DEVICES);
uint8_t degC[] = { 6, 3, 3, 56, 68, 68, 68 };  // Deg C
uint8_t degF[] = { 6, 3, 3, 124, 20, 20, 4 };  // Deg F
uint8_t clear = 0x00;
char szMesg[MAX_MESG + 1] = "";
*/
#define PRINTS(x)
MD_MAX72XX mx = MD_MAX72XX(HARDWARE_TYPE, CS_PIN, MAX_DEVICES);
// We always wait a bit between updates of the display
#define  DELAYTIME  50  // in milliseconds


void scrollText(const char *p)
{
  uint8_t charWidth;
  uint8_t cBuf[8];  // this should be ok for all built-in fonts

  PRINTS("\nScrolling text");
  mx.clear();

  while (*p != '\0')
  {
    charWidth = mx.getChar(*p++, sizeof(cBuf) / sizeof(cBuf[0]), cBuf);

    for (uint8_t i=0; i<=charWidth; i++)  // allow space between characters
    {
      mx.transform(MD_MAX72XX::TSL);
      mx.setColumn(0, (i < charWidth) ? cBuf[i] : 0); 
      // delay(DELAYTIME);
     
     for (uint8_t j=0; j<=16; j++) {
        delayMicroseconds(10000000);        
     }  
     
    }
  }
}







#define CHAR_SPACING  1 // pixels between characters

void printText(uint8_t modStart, uint8_t modEnd, char *pMsg)
// Print the text string to the LED matrix modules specified.
// Message area is padded with blank columns after printing.
{
  uint8_t   state = 0;
  uint8_t   curLen;
  uint16_t  showLen;
  uint8_t   cBuf[8];
  int16_t   col = ((modEnd + 1) * COL_SIZE) - 1;

  mx.control(modStart, modEnd, MD_MAX72XX::UPDATE, MD_MAX72XX::OFF);

  do     // finite state machine to print the characters in the space available
  {
    switch(state)
    {
      case 0: // Load the next character from the font table
        // if we reached end of message, reset the message pointer
        if (*pMsg == '\0')
        {
          showLen = col - (modEnd * COL_SIZE);  // padding characters
          state = 2;
          break;
        }

        // retrieve the next character form the font file
        showLen = mx.getChar(*pMsg++, sizeof(cBuf)/sizeof(cBuf[0]), cBuf);
        curLen = 0;
        state++;
        // !! deliberately fall through to next state to start displaying

      case 1: // display the next part of the character
        mx.setColumn(col--, cBuf[curLen++]);

        // done with font character, now display the space between chars
        if (curLen == showLen)
        {
          showLen = CHAR_SPACING;
          state = 2;
        }
        break;

      case 2: // initialize state for displaying empty columns
        curLen = 0;
        state++;
        // fall through

      case 3:  // display inter-character spacing or end of message padding (blank columns)
        mx.setColumn(col--, 0);
        curLen++;
        if (curLen == showLen)
          state = 0;
        break;

      default:
        col = -1;   // this definitely ends the do loop
    }
  } while (col >= (modStart * COL_SIZE));

  mx.control(modStart, modEnd, MD_MAX72XX::UPDATE, MD_MAX72XX::ON);
}




// RFID
#include <MFRC522.h>
#define RST_PIN         9          // Configurable, see typical pin layout above
#define SS_PIN          3         // Configurable, see typical pin layout above
#define IRQ_PIN         2           // Configurable, depends on hardware
MFRC522 mfrc522(SS_PIN, RST_PIN);  // Create MFRC522 instance

MFRC522::MIFARE_Key key;
volatile bool bNewInt = false;
byte regVal = 0x7F;
void activateRec(MFRC522 mfrc522);
void clearInt(MFRC522 mfrc522);




char stringTochar(String s)
{
char arr[12];
s.toCharArray(arr, sizeof(arr));
return atol(arr);
}


void setup() {
  //pinMode(interruptPin, INPUT_PULLUP);

  pinMode(A1, OUTPUT);  // Relé 1
  pinMode(A2, OUTPUT);  // Relé 2
  pinMode(A3, OUTPUT);  // Relé 3
  pinMode(A4, OUTPUT);  // Relé 4


 

  Serial.begin(115200);
  Serial.flush();

  pinMode(pin_inundacion, INPUT); 
  pinMode(pin_temperatura, INPUT_PULLUP);
  pinMode(pin_llama, INPUT); 


  dht.begin();
  mq2.begin();


  // Display leds
  PRINTS("\n[MD_MAX72XX Test & Demo]");
  if (!mx.begin())
    PRINTS("\nMD_MAX72XX initialization failed");
      
  /*
  Wire.begin();
  P.begin(2);
  P.setInvert(false);
  P.setZone(0, MAX_DEVICES - 4, MAX_DEVICES - 1);
  P.setZone(1, MAX_DEVICES - 4, MAX_DEVICES - 1);
  P.displayZoneText(0, szMesg, PA_CENTER, SPEED_TIME, 0, PA_PRINT, PA_NO_EFFECT);
  P.addChar('$', degC);
  P.addChar('&', degF);
  */

  

  // RFID
  SPI.begin();      // Init SPI bus
  mfrc522.PCD_Init(); // Init MFRC522 card
  /* read and printout the MFRC522 version (valid values 0x91 & 0x92)*/
  // Serial.print(F("Ver: 0x"));
  byte readReg = mfrc522.PCD_ReadRegister(mfrc522.VersionReg);
  // Serial.println(readReg, HEX);

  digitalWrite(A1, HIGH); // Relé 1 apagado
  digitalWrite(A2, HIGH); // Relé 2 apagado
  digitalWrite(A3, HIGH); // Relé 3 apagado
  digitalWrite(A4, HIGH); // Relé 4 apagado

  //pinMode(7, OUTPUT);
  //digitalWrite(7, HIGH);  // Buzzer apagado
}


// unsigned long time;

void loop () {
  

 // Serial.print("Time: ");
  //time = millis();
  //Serial.println(time);    //prints time since program started

  /*
  mfrc522.PICC_ReadCardSerial();    //read the tag data

  // Show some details of the PICC (that is: the tag/card)
  Serial.print(F("- - - - - - - - - - Card UID:"));
  dump_byte_array(mfrc522.uid.uidByte, mfrc522.uid.size);
  Serial.println();
  mfrc522.PICC_HaltA();
  memset(mfrc522.uid.uidByte, 0, sizeof(mfrc522.uid.uidByte)); // clear the bytes
  */

// Revisamos si hay nuevas tarjetas  presentes
  if ( mfrc522.PICC_IsNewCardPresent()) 
        {  
      //Seleccionamos una tarjeta
            if ( mfrc522.PICC_ReadCardSerial()) 
            {

                  unsigned long tempUID[4] = {0};

                  String content = "";
                  
              
                  // Enviamos serialemente su UID
                  // Serial.print("Card UID:");
                  for (byte i = 0; i < mfrc522.uid.size; i++) {
                          // Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
                          // Serial.print(mfrc522.uid.uidByte[i], HEX);   
                 

                  tempUID[i] = mfrc522.uid.uidByte[i];

                  content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
                  content.concat(String(mfrc522.uid.uidByte[i], HEX));

                          
                  } 
                  // Serial.println();
                  // Terminamos la lectura de la tarjeta  actual
                  mfrc522.PICC_HaltA();         


                  volatile unsigned long UID = 0;
                  UID |= (tempUID[0] << 24);
                  UID |= (tempUID[1] << 16);
                  UID |= tempUID[2] << 8;
                  UID |= tempUID[3];
//                  Serial.print("---TARJETA----: ");
//                  Serial.println(UID);


                  content.toUpperCase();
                  String UIDst = content.substring(1);
//                  Serial.println(UIDst);


                  //char mystr[40];
                  //sprintf(mystr,"%u", UIDst);
                  // Serial.println(mystr);

                  Serial.println();
                  Serial.println("{" + UIDst + "|" + UID + "}");   
                  Serial.println();


                  // String valida = "7A 96 5B 58";
                  // if(UIDst.substring(0, 11) == valida) {
                  /*
                  if(UIDst.substring(0, 11) == "7A 96 5B 58") {
                  // if(UIDst.substring(9, 2) == "38") {
                    digitalWrite(A2, LOW); // Relé 2 activado
                    Serial.println("Tarjeta correcta, abriendo puerta..............");
                    delay(2000);
                    digitalWrite(A2, HIGH); // Relé 2 apagado
                  } else {
                    Serial.println("Tarjeta no válida !!!!!!!!!____" + UIDst.substring(0, 11)+"____" + "_______");
                    delay(2000);
                  }                  
                  */

                  /*
                  char mystr[40];
                  sprintf(mystr,"Tarjeta: %u", tempUID);
                  Serial.println(mystr);
                  */
/*
                    pinMode(A2, OUTPUT);
                    digitalWrite(A2, LOW);  // Relé 2 activado
                    Serial.println("Recibido Relé 2 ON");
*/                    
                  delay(100);



                  
            }      
  } 


   

  String input = "";
  String st = "";
  String linea1 = "";
  String linea2 = "";



 
  // El siguiente bucle lee cualquer entrada de datos por el puerto serie (USB) y la va almacenando en la cadena "input"
  while (Serial.available() > 0)
  {
    input += (char) Serial.read(); // Lee un caracter cada vez
    delay(5); // Espera 5 ms hasta que se reciba el siguiente caracter
  }

  // Cuando ya terminó de leer la cadena (input) comprueba si los datos recibidos incluyen alguna de las "instrucciones" 
  // previstas en las siguientes líneas de código: "on", "off", "pregunta" y "lcd"...

  // Serial.println("Orden recibida...... " + input);



  // <--- Activar-Desactivar los relés ---
  // Si la orden recibida es "r1_on" enciende el relé 1 que permanece encendido  
  if (input.substring(0, 5) == "r1_on") {
    pinMode(A1, OUTPUT);
    digitalWrite(A1, LOW);  // Relé 1 activado
    delay(100);
    Serial.println("[R1_ON]");
  }
  // Si la orden recibida es "r1_off" apaga el relé 1
  if (input.substring(0, 6) == "r1_off") {
    pinMode(A1, OUTPUT);
    digitalWrite(A1, HIGH);  // Relé 1 apagado
    delay(100);
    Serial.println("[R1_OFF]");
  }

  // Si la orden recibida es "r2_on" enciende el relé 2 que permanece encendido  
  if (input.substring(0, 5) == "r2_on") {
    pinMode(A2, OUTPUT);
    digitalWrite(A2, LOW);  // Relé 2 activado
    delay(100);
    Serial.println("[R2_ON]");
  }
  // Si la orden recibida es "r2_off" apaga el relé 2
  if (input.substring(0, 6) == "r2_off") {
    pinMode(A2, OUTPUT);
    digitalWrite(A2, HIGH);  // Relé 2 apagado
    delay(100);
    Serial.println("[R2_OFF]");
  }

  // Si la orden recibida es "r3_on" enciende el relé 3 que permanece encendido  
  if (input.substring(0, 5) == "r3_on") {
    pinMode(A3, OUTPUT);
    digitalWrite(A3, LOW);  // Relé 3 activado
    delay(100);
    Serial.println("[R3_ON]");
  }
  // Si la orden recibida es "r3_off" apaga el relé 3
  if (input.substring(0, 6) == "r3_off") {
    pinMode(A3, OUTPUT);
    digitalWrite(A3, HIGH);  // Relé 3 apagado
    delay(100);
    Serial.println("[R3_OFF]");
  }

  // Si la orden recibida es "r4_on" enciende el relé 4 que permanece encendido  
  if (input.substring(0, 5) == "r4_on") {
    pinMode(A4, OUTPUT);
    digitalWrite(A4, LOW);  // Relé 4 activado
    delay(100);
    Serial.println("[R_ON]");
  }
  // Si la orden recibida es "r4_off" apaga el relé 4
  if (input.substring(0, 6) == "r4_off") {
    pinMode(A4, OUTPUT);
    digitalWrite(A4, HIGH);  // Relé 4 apagado
    delay(100);
    Serial.println("[R4_OFF]");
  }
  // >--- Activar-Desactivar los relés ---





  // <--- Activa-Desactiva el buzzer de alarma ---
  // Si la orden recibida es "buzz_on" enciende el buzzer que permanece encendido  
  /*
  if (input.substring(0, 7) == "buzz_on") {
    digitalWrite(7, LOW);  // Buzzer activado
  }
  // Si la orden recibida es "buzz_off" apaga el buzzer de alarma
  if (input.substring(0, 8) == "buzz_off") {
    digitalWrite(7, HIGH);  // Buzzer apagado
  }
  */
  // >--- Activa-Desactiva el buzzer de alarma ---

 
  // Serial.println(inundacion);

  /*  
  // Sensor de inundación (pin Digital)
  if( digitalRead(pin_inundacion) == LOW) {
    Serial.println("Inundación: NO");
  } else {
    Serial.println("Inundación: SI");
    }
  */




    
  
  // Sensor de inundación (pin Analógico)    
  static uint32_t inundacion = 0; 
  inundacion = analogRead(pin_inundacion);
  /*
  if (inundacion>100) {
    Serial.print("Inundación: SI   Nivel: ");
    Serial.println(inundacion);
  } else
    {
      Serial.print("Inundación: NO   Nivel: ");
      Serial.println(inundacion);
    }
  */
  


  // Sensor de temperatura-humedad relativa
  float temperatura = dht.readTemperature();
  float humedad = dht.readHumidity();
  /*
  Serial.print("Humedad: "); 
  Serial.println(humedad);
  Serial.print("Temperatura: ");
  Serial.println(temperatura);
  */
  
  

  /*
  char str_temperatura[5];
  dtostrf(temperatura, 2, 1, str_temperatura);
  String cadena = "";
  cadena = "Temperatura: " + String(dtostrf(temperatura, 2, 1, str_temperatura)) + (char)223 +"C";
  // scrollText(cadena.c_str());
  // delay(100);

  char str_humedad[5];
  dtostrf(humedad, 2, 1, str_humedad);
  cadena = "Humedad relativa: " + String(dtostrf(humedad, 2, 1, str_humedad)) + "%";
  // scrollText(cadena.c_str());
  // delay(100);
  */


  
  // PANTALLA LEDS
  /*
  char str_temperatura[4];
  dtostrf(temperatura, 2, 1, str_temperatura);
  String cadena = "";
  cadena = "Temp: " + String(dtostrf(temperatura, 2, 1, str_temperatura)) + "~C";
  // cadena = String(dtostrf(temperatura, 2, 1, str_temperatura)) + "~C";
  scrollText(cadena.c_str());
  
  char str_humedad[4];
  dtostrf(humedad, 2, 1, str_humedad);

  cadena = "Hum: " + String(dtostrf(humedad, 2, 1, str_humedad)) + " %";
  // cadena = String(dtostrf(humedad, 2, 1, str_humedad)) + " %";
  scrollText(cadena.c_str());
  */
  

  
  char str_temperatura[4];
  dtostrf(temperatura, 2, 1, str_temperatura);
  String cadena1 = "";
  // cadena1 = String(dtostrf(temperatura, 2, 1, str_temperatura)) + (char)223 +"C";
  cadena1 = String(dtostrf(temperatura, 2, 1, str_temperatura)) + "~C";

  char str_humedad[4];
  dtostrf(humedad, 2, 1, str_humedad);
  String cadena2 = "";
  cadena2 = String(dtostrf(humedad, 2, 1, str_humedad)) + " %";  
  
  actualiza_pantalla = actualiza_pantalla + 1; 

  if(actualiza_pantalla == 1) { 
     printText(0, MAX_DEVICES-1, "Temp:");
  }   

  if(actualiza_pantalla == 2) { 
     printText(0, MAX_DEVICES-1, cadena1.c_str());
  }   

  if(actualiza_pantalla == 5) { 
     printText(0, MAX_DEVICES-1, "Hum:");
  }   

  if(actualiza_pantalla == 6) { 
     printText(0, MAX_DEVICES-1, cadena2.c_str());
  }   



  

  // Sensor de llama-incendio
  int llama = digitalRead(pin_llama);
  /*
  if (llama == LOW)
   {
     Serial.println("Incendio-Detección de llama: SI");   
   } else {
     Serial.println("Incendio-Detección de llama: NO");   
     }
  */
  


  // Sensor de humo, GLP y CO - Sensor MQ-2 (conexión analógica)
  // float* values = mq2.read(true);  // Imprime automáticamente los valores en el puerto serie
  // float* values = mq2.read(false);  // No imprime automáticamente los valores en el puerto serie
  
  glp = mq2.readLPG();
  co = mq2.readCO();
  humo = mq2.readSmoke();

  /*
  Serial.print("Sensor de humo, GLP y CO (Analógico. Partes por millón): ");
  Serial.print("   GLP: " + String(lpg));
  Serial.print("   CO: " + String(co));
  Serial.println("   Humo: " + String(smoke));
  */
  


  // Sensor de humo, GLP y CO - Sensor MQ-2 (conexión digital)
  int humo_d = digitalRead(pin_humo_digital);
  /*
  if (humo_d == LOW)
   {
      Serial.println("Detección de gases (humo, GLP, CO): SI");   
   } else {
        Serial.println("Detección de gases (humo, GLP, CO): NO");   
     }
  */
  
  


  
  
  // rfid_leer_serie();

  
  // scrollText("Graphics");


  if(actualiza_pantalla > 8) {
    actualiza_pantalla = 0;
  }
 

  // delay(100);
  
  Serial.println("<" + String(inundacion) + "|" + temperatura + "|" + humedad + "|" + llama + "|" + glp + "|" + co + "|" + humo + "|" + humo_d + ">");   
  
}





/**
 * Helper routine to dump a byte array as hex values to Serial.
 */
void dump_byte_array(byte *buffer, byte bufferSize) {
  for (byte i = 0; i < bufferSize; i++) {
    Serial.print(buffer[i] < 0x10 ? " 0" : " ");
    Serial.print(buffer[i], HEX);
  }
}
